package ru.dbotthepony.mc.otm.client.screen.panels

import net.minecraft.client.gui.components.EditBox
import net.minecraft.network.chat.Component
import ru.dbotthepony.mc.otm.core.TextComponent
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

open class EditBoxPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 0f,
	height: Float = 20f,
	val defaultText: Component = TextComponent("")
) : MinecraftWidgetPanel<EditBox>(screen, parent, x, y, width, height) {
	override fun makeNew(): EditBox {
		return object : EditBox(font, 0, 0, width.toInt(), height.toInt().coerceAtMost(20), defaultText) {
			override fun isHoveredOrFocused(): Boolean {
				return this@EditBoxPanel.isHovered
			}

			override fun isFocused(): Boolean {
				return this@EditBoxPanel.isFocused
			}
		}
	}

	init {
		autoKillFocus = true
	}

	override fun copyValues(new_widget: EditBox, old_widget: EditBox) {
		new_widget.value = old_widget.value
	}

	override fun tick() {
		super.tick()
		widget?.tick()
	}

	override fun configureNew(widget: EditBox, recreation: Boolean) {
		widget.setFocus(isFocused)
	}

	override fun onFocusChanged(new: Boolean, old: Boolean) {
		widget?.setFocus(new)
	}

	override fun mouseClickedInner(x: Double, y: Double, flag: Int): Boolean {
		super.mouseClickedInner(x, y, flag)
		requestFocus()
		return true
	}
}