package ru.dbotthepony.mc.otm.core

import net.minecraft.nbt.CompoundTag
import net.minecraft.nbt.Tag
import java.util.UUID

operator fun CompoundTag.set(index: String, value: Tag) = 				put(index, value)
operator fun CompoundTag.set(index: String, value: Int) = 				putInt(index, value)
operator fun CompoundTag.set(index: String, value: Byte) = 				putByte(index, value)
operator fun CompoundTag.set(index: String, value: Short) = 			putShort(index, value)
operator fun CompoundTag.set(index: String, value: Long) = 				putLong(index, value)
operator fun CompoundTag.set(index: String, value: Float) = 			putFloat(index, value)
operator fun CompoundTag.set(index: String, value: Double) = 			putDouble(index, value)
operator fun CompoundTag.set(index: String, value: String) = 			putString(index, value)
operator fun CompoundTag.set(index: String, value: Boolean) = 			putBoolean(index, value)
operator fun CompoundTag.set(index: String, value: ByteArray) = 		putByteArray(index, value)
operator fun CompoundTag.set(index: String, value: IntArray) = 			putIntArray(index, value)
operator fun CompoundTag.set(index: String, value: LongArray) = 		putLongArray(index, value)

operator fun CompoundTag.set(index: String, value: UUID) = 				putUUID(index, value)

fun CompoundTag.contains(vararg keys: String): Boolean {
	for (key in keys) {
		if (!contains(key)) {
			return false
		}
	}

	return true
}

inline fun <R, reified T : Tag> CompoundTag.map(s: String, consumer: (T) -> R): R? {
	val tag = get(s)

	if (tag is T) {
		return consumer(tag)
	}

	return null
}

inline fun CompoundTag.ifHas(s: String, consumer: (Tag) -> Unit) {
	val tag = get(s)

	if (tag != null) {
		consumer(tag)
	}
}

inline fun CompoundTag.ifHas(s: String, type: Byte, consumer: (Tag) -> Unit) {
	val tag = get(s)

	if (tag != null && tag.id == type) {
		consumer(tag)
	}
}

inline fun <reified T : Tag> CompoundTag.ifHas(s: String, type: Class<T>, consumer: (T) -> Unit) {
	val tag = get(s)

	if (tag != null && tag::class.java === type) {
		consumer(tag as T)
	}
}
